/* date created: 6-24-2013

is_paused = 0 (not paused)
is_paused = 1 (auto paused)
is_paused = 2 (manually paused)

*/



mob
	var/tmp/is_paused = 0

	proc/check_focus()
		spawn // allows this proc to process without stoping everything

			var/obj/maptext = new // create a new object
			maptext.maptext = "Paused!" // set the text for maptext.
			maptext.screen_loc = "CENTER, CENTER" // makes maptext display in the middle of the screen

			while(src) // this proc will repeat until the user logs out
				sleep(1) // allows the proc to sleep.

				var/has_focus = winget(usr, "MainWindow", "focus") // create a var which grabs the focus of the window

				switch(has_focus)
					if("true") // if user has focus
						if(src.is_paused==2) continue // if game was manually paused; don't unpause game.
						src.unPause_Game() // unpause game

					else if("false") // if user doesn't have focus
						if(!src.is_paused) // if game isn't paused.
							src.Pause_Game() // pause game
							src.is_paused = 1 // change var from 2 to 1 cause check_focus toggled pause
						else if(src.is_paused==2) continue // if game isn't paused, and if it's manually paused, restart proc.