mob
	verb
		pause_game()
			set name = "Pause Game"
			if(src.is_paused)
				src.unPause_Game()
				return

			src.Pause_Game()



	proc
		Pause_Game()
			if(src.is_paused) return

			var/obj/maptext = new                 // create a new object
			maptext.maptext = "Paused!"           // set the text for maptext.
			maptext.tag     = "HUD Paused"
			maptext.screen_loc = "CENTER, CENTER" // makes maptext display in the middle of the screen

			// I just provided quick border effects
			// you could use my MaptextPro library for more easier border effects
			// link: http://www.byond.com/developer/Flysbad/MaptextPro
			var/obj/tr = new
			tr.maptext = "<font color=black>[maptext.maptext]"
			tr.pixel_x ++ ; tr.pixel_y ++

			var/obj/tl = new
			tl.maptext = "<font color=black>[maptext.maptext]"
			tl.pixel_x -- ; tl.pixel_y ++

			var/obj/br = new
			br.maptext = "<font color=black>[maptext.maptext]"
			br.pixel_x ++ ; br.pixel_y --

			var/obj/bl = new
			bl.maptext = "<font color=black>[maptext.maptext]"
			bl.pixel_x -- ; bl.pixel_y --

			maptext.underlays = null              // clear underlays because we don't want 10000 border effects.
			maptext.underlays.Add(tr, tl, br, bl) // add the 4 border effects

			src.client.screen += maptext          // add maptext to the users screen.

			src.is_paused = 2 // game is manually paused


		unPause_Game()
			if(!src.is_paused) return

			for(var/obj/object in src.client.screen)
				if(object.tag == "HUD Paused") del(object)

			src.is_paused = 0